#!/usr/bin/env node
let fs = require('fs');
var cli = require('cli');
var cmd = require('node-cmd');
options = cli.parse();
var text = __dirname + '/info/Welcome.txt';
if(options.name && options.name !== '') {
    if(fs.existsSync(text)) {
        fs.readFile(text, (err,data) => {
                if(err) {
                        console.log(err);
                } else {
                        cli.ok(data.toString());
                }
        });
    }
    cli.ok("Creating ...");
    cmd.get("npm i -g vn-native-2-cmd && npm i -g vn-native-resource && git clone https://github.com/steveleetn91/vn-native-2.git " + options.name,(err, data, stderr) => {
        if(err) {
            console.log(err);
        } else {
            cli.ok("Please waiting a moments");
            addWebViewPlugin(options.name);
        }
    });
}

function addWebViewPlugin(name){
    cmd.get('npm i -g cordova && cd ./' + name + '/app && npm install && cordova plugin add cordova-plugin-wkwebview-engine && cordova plugin add cordova-plugin-splashscreen && rm -rf ./.git',(err, data, stderr) => {
        if(err) {
            console.log(err);
        } else {
            cli.ok("Done ...");
        }
    });
}
/**
 * Info 
 */
if(options.info) {
    if(fs.existsSync(__dirname + "/info/ProjectInfo.txt")) {
        fs.readFile(__dirname + "/info/ProjectInfo.txt", (err,data) => {
            if(err) {
                    console.log(err);
            } else {
                let packagePath = './package.json';
                if(fs.existsSync(packagePath)) {
                    let info = data.toString();
                    fs.readFile(packagePath,(_err,_data) => {
                        if(_err) {
                            console.log(_err);
                        } else {
                            let packageJson = JSON.parse(_data);
                            info = info.replace('#Platforms',packageJson.cordova.platforms.toString());
                            let depend = '';
                            if(packageJson.dependencies['vn-native-js']) {
                                depend += 'vn-native-js  ' + packageJson.dependencies['vn-native-js'] + "\n";
                            }
                            if(packageJson.dependencies['cordova-android']) {
                                depend += 'Android core ' + packageJson.dependencies['cordova-android'] + "\n";
                            }
                            if(packageJson.dependencies['cordova-android']) {
                                depend += 'Browser core ' + packageJson.dependencies['cordova-browser'] + "\n";
                            }
                            if(packageJson.dependencies['cordova-ios']) {
                                depend += 'iOS core ' + packageJson.dependencies['cordova-ios'] + "\n";
                            }
                            if(packageJson.dependencies['cordova-osx']) {
                                depend += 'Osx core ' + packageJson.dependencies['cordova-osx'] + "\n";
                            }
                            if(packageJson.dependencies['cordova-plugin-dialogs']) {
                                depend += 'Notification ' + packageJson.dependencies['cordova-plugin-dialogs'] + "\n";
                            }
                            if(packageJson.dependencies['vn-native-local-cloud']) {
                                depend += 'LocalCloud ' + packageJson.dependencies['vn-native-local-cloud'] + "\n";
                            }
                            info = info.replace('#Plugins',depend);
                            cli.ok(info);
                        }
                    });
                } else {
                    console.error("You need create Vn Native 2 Project");
                }
            }
        });
    }
}